# Overview
mem_chk_perm is a simple utility that tests memory access permissions from a 
userspace application's perspective. It helps analyze writable regions in 
memory, by testing the start, the middle and the end of each region.

# Usage
```
mem_chk_perm
```
# Sample Output
```
Memory Layout:
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| Memory Region                           | Perms| content                                  | Result Bottom        | Result middle        | Result upper         | Overall |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x0000000000000000 - 0x000055f0caf06000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf06000 - 0x000055f0caf07000 | r--p | /tmp/mem_chk_perm/mem_chk_perm           | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf07000 - 0x000055f0caf09000 | r-xp | /tmp/mem_chk_perm/mem_chk_perm           | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf09000 - 0x000055f0caf0a000 | r--p | /tmp/mem_chk_perm/mem_chk_perm           | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf0a000 - 0x000055f0caf0b000 | r--p | /tmp/mem_chk_perm/mem_chk_perm           | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf0b000 - 0x000055f0caf0c000 | rw-p | /tmp/mem_chk_perm/mem_chk_perm           | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0caf0c000 - 0x000055f0f89eb000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0f89eb000 - 0x000055f0f8a31000 | rw-p | [heap]                                   | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x000055f0f8a31000 - 0x00007f08efbdf000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efbdf000 - 0x00007f08efc01000 | r--p | /usr/lib/x86_64-linux-gnu/libc-2.31.so   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efc01000 - 0x00007f08efd79000 | r-xp | /usr/lib/x86_64-linux-gnu/libc-2.31.so   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efd79000 - 0x00007f08efdc7000 | r--p | /usr/lib/x86_64-linux-gnu/libc-2.31.so   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efdc7000 - 0x00007f08efdcb000 | r--p | /usr/lib/x86_64-linux-gnu/libc-2.31.so   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efdcb000 - 0x00007f08efdcd000 | rw-p | /usr/lib/x86_64-linux-gnu/libc-2.31.so   | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efdcd000 - 0x00007f08efdd3000 | rw-p | [anonymous]                              | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efdd3000 - 0x00007f08efe02000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe02000 - 0x00007f08efe03000 | r--p | /usr/lib/x86_64-linux-gnu/ld-2.31.so     | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe03000 - 0x00007f08efe26000 | r-xp | /usr/lib/x86_64-linux-gnu/ld-2.31.so     | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe26000 - 0x00007f08efe2e000 | r--p | /usr/lib/x86_64-linux-gnu/ld-2.31.so     | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe2e000 - 0x00007f08efe2f000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe2f000 - 0x00007f08efe30000 | r--p | /usr/lib/x86_64-linux-gnu/ld-2.31.so     | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe30000 - 0x00007f08efe31000 | rw-p | /usr/lib/x86_64-linux-gnu/ld-2.31.so     | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007f08efe31000 - 0x00007f08efe32000 | rw-p | [anonymous]                              | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
|*0x00007f08efe32000 - 0x00007ffd1f717000*| ---- | [unmapped]                               | denied               | denied               | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
|*0x00007ffd1f717000 - 0x00007ffd1f738000*| rw-p | [stack]                                  | written ok           | written ok           | written ok           | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007ffd1f738000 - 0x00007ffd1f7bb000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007ffd1f7bb000 - 0x00007ffd1f7bf000 | r--p | [vvar]                                   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007ffd1f7bf000 - 0x00007ffd1f7c1000 | r-xp | [vdso]                                   | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0x00007ffd1f7c1000 - 0xffffffffff600000 | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0xffffffffff600000 - 0xffffffffff601000 | --xp | [vsyscall]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
| 0xffffffffff601000 - 0xffffffffffffffff | ---- | [unmapped]                               | denied               | denied               | denied               | PASS    |
+-----------------------------------------+------+------------------------------------------+----------------------+----------------------+----------------------+---------+
```

# Observations
While testing end-region writes, a specific behavior was observed that 
aligns with Linux’s expected stack handling. 
Memory just before the stack boundary appeared writable, despite being 
shown as unmapped in /proc/self/maps. 
This is due to Linux intentionally leaving the bottom of the stack 
unmapped so that any write to this region triggers a page fault. 
The kernel handles this by expanding the stack to accommodate the 
access. 
After a successful write, the unmapped region and the stack region
change, the page where the write is made gets added to the stack
and removed from the unmapped.


# Notes
* Zones whose address are wrapped in "*" are changed during operation.
* Writing to the memory zone before the stack may not always trigger 
  a segmentation fault due to this pre-allocation.
* The pass column reports if the behavior expected is reflected by
  the test.
